//Thread che gestisce la comunicazione interna con l'altro Server 

import java.net.*;
import java.io.*;

public class ConnessioneInterna implements Runnable{
	
	//Connessione interna con l'altro Server
	Socket socketServer;
	
	//Costruttore
	public ConnessioneInterna(Socket sock){
		socketServer = sock;
	}
	
	public void run(){
		try{
				
				//Stream di ingresso dall'altro Server 
				DataInputStream inStreamServer = new DataInputStream(socketServer.getInputStream());
						
				byte request[] = new byte[10];
				
		/*	Ritardo per lettura completa,
				modificare con lettura di singoli caratteri
		*/		
				try{
			//			System.out.println("Ritardo di 1 secondo per aspettare la lettura");
						Thread.sleep(500);
				}catch(InterruptedException e){}
			
				
				int byteLetti = inStreamServer.read(request);
				String richiesta = new String(request);
									
				//Estrazione operazione e nome del file
				String op = richiesta.substring(0,1);
				String nomeFile = richiesta.substring(2,10);
								
				//Esecuzione della operazione
				Operazione operazione = new Operazione();
				boolean esito= operazione.op(nomeFile,op);
				System.out.println("Esito operazione sul Server Secondario '"+esito+"'");
				
				//Attesa di 5 secondi per testare la connessione	
				try{
					System.out.println("Ritardo di 5 secondi per simulare la caduta del Server Principale");
					Thread.sleep(5000);
				}catch(InterruptedException e){}
			
				try{
				//Stream di uscita per il Server Principale
				DataOutputStream outStreamServer = new DataOutputStream(socketServer.getOutputStream());
				outStreamServer.writeBoolean(esito);
				System.out.println("Spedito al Server Principale '"+esito+"'");
				}catch(IOException ex){
					/*Se esito,sul Server Secondario positivo e Server Primario
						in crash, disfare l'operazione sul Server Secondario	
					*/
				
					if(esito){
						System.out.println("           CRASH del Server Principale");
						System.out.println("Attivato PROTOCOLLO di RECOVERY ");
						if(op.equals("+")){op="-";}
					 	else op="+";
						//Esecuzione della operazione di recovery
						Operazione operazioneRecovery = new Operazione();
						boolean esitoRecovery = operazioneRecovery.op(nomeFile,op);
						System.out.println("Esito operazione di Recovery sul Server Secondario '"+esitoRecovery+"'");
					
					}
				 }
				
				socketServer.close();
								   	  
		}catch(SocketException sex){
			System.out.println("Errore di connessione  "+sex.getMessage());
		 }
	  catch(IOException ioex){
	  	System.out.println("Errore  "+ioex.getMessage());
	   }
	}
	
}