import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class ContatoreWAP extends HttpServlet 
{
		String ServerPrincipale;
		String ServerSecondario;
					
	//Variabili che permettono il bilanciamento 
	//delle richieste sui due Server
		int ContServer_I;
		int ContServer_II; 
		
  //Variabile che mantiene la connessione con il Server  remoto 
   	Socket serverConnesso; 
	
	/*Metodo per creare la connessione con un Server. 
		Riceve in ingresso la porta e l'host remoto e ritorna una
		socket che identifica la connessione aperta 
	*/
		public Socket connessioneServerWEB(String HostRemoto,int Porta) throws IOException{
			try{
				InetAddress ServerRemoto = InetAddress.getByName(HostRemoto);
    		//Creazione della connessione con il primo Server 
    		Socket server = new Socket(ServerRemoto,Porta);
				System.out.println("Connessione con il Server Principale: "+HostRemoto);
				return server;
			}catch(SocketException sex_0){throw sex_0;}
	
		}	

	/*Metodo per la gestione della risposta al Terminale WAP.
		La risposta viene spedita in linguaggio WML(Wireless Markup Language)
	*/

		public void gestineRisposta(HttpServletResponse response,boolean esito,String richiesta){
			try{
					response.setContentType("text/vnd.wap.wml");
         PrintWriter out = response.getWriter();
         out.println("<?xml version=\"1.0\"?>");
         out.println("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.wapforum.org/DTD/wml_1.1.xml\">");
         out.println("<wml>");
         out.println("<card id=\"card1\" title=\"Risposta\">");
         out.println("<p>");
         out.println("Inviato : ");
         out.println("<b>");
         out.println(richiesta);
         out.println("</b>");
         out.println("<br/>");
         out.println("Esito : ");
         out.println("<b>");
         if(esito){out.println(" OK !!");}
         else{out.println(" Errore !!");}
         out.println("</b>");
         out.println("</p>");
         out.println("</card>");
         out.println("</wml>");
         out.close();
         System.out.println("Spedito al Terminale WAP  '"+esito+"'");
         System.out.println("---------------------------------");
				}catch(IOException ioex){
						System.out.println("Errore IO: "+ioex.getMessage());
					} 

		
		}

	/*Metodo per la gestione del servizio richiesto.
		Riceve in ingresso la socket che identifica la connessione 
		con il Server WEB remoto.
	*/
		public boolean gestioneServizio(Socket server,String parametri,String nameServer){
				//Risultato inviato al Terminale WAP
    			boolean Risultato = false;
    	try
				 {
    			//Stream di uscita
					DataOutputStream outStream = new DataOutputStream(server.getOutputStream());
				
					//Invio della richiesta come stringa(bytes) 
					outStream.writeBytes(parametri);
					outStream.flush();
					System.out.println("Spedito '"+parametri+"' al Server Principale "+nameServer);
				
					//Stream di ingresso
					DataInputStream inStream = new DataInputStream(server.getInputStream());
					Risultato = inStream.readBoolean();
					System.out.println("Ricevuto dal Server Principale "+nameServer+" '"+Risultato+"'");			
					
        }catch(SocketException sex){
					 System.out.println("Errore Socket  "+sex.getMessage());
				  }catch(IOException ioex){
			 			System.out.println("Errore IO  "+ioex.getMessage());
			  	 }finally{return Risultato;}		
		}

    public void init(ServletConfig config) throws ServletException
    {
        super.init(config);
        
        //Inserimento dell'indirizzo dei due Server WEB dal Server WAP (Nokia)
        ServerPrincipale = config.getInitParameter("server_I");
       // if(ServerPrincipale == null){ServerPrincipale="lab2-pc03";} 
        
        ServerSecondario = config.getInitParameter("server_II");
       // if(ServerSecondario == null){ServerSecondario="LAB2-PC04";}
        
        //Inizializzazione dei contatori per gestire il bilanciamento 
        //delle richiese ai due Server WEB
        ContServer_I  = 0;
        ContServer_II = 0; 
    }

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
    		System.out.println("---------------------------------");
    		
    	//Recupero dei parametri inviati dal Terminale WAP
    		 String param = request.getParameter("richiesta");
    	//Visualizzazione dei parametri Sul Server WAP
    		 System.out.println("Parametri ricevuti : '"+param+"'");
    	
    	//Gestione del bilanciamento del carico	 sui due Server WEB
    	//con relativa connessione, se questa fallisce si prova 
    	//sull'altro Server WEB
    	
    	//Esito operazione
    	boolean esitoOperazione = false;
    	//Porta
				int remotePort = 1234;
    		
    		if((ContServer_II > ContServer_I)||(ContServer_I == ContServer_II))
    			{try
    				{
    					//Creazione connessione con il Server WEB remoto
    					serverConnesso = connessioneServerWEB(ServerPrincipale,remotePort);
    					//Incremento del contatore	
							ContServer_I = ContServer_I+1;
							//Gestione della richiesta	
							esitoOperazione = gestioneServizio(serverConnesso,param,ServerPrincipale);
							//Gestione della risposta al Terminale WAP
							gestineRisposta(response,esitoOperazione,param);
							//Decremento del contatore
							ContServer_I = ContServer_I-1;
    			  }catch(SocketException sex_1)
    			  	{try
    			  		{	System.out.println("Connessione al Server Principale: "+ServerPrincipale+" fallita");
    			  			//Creazione connessione con il Server WEB remoto
    							serverConnesso = connessioneServerWEB(ServerSecondario,remotePort);
    							//Incremento del contatore	
									ContServer_II = ContServer_II+1;
									//Gestione della richiesta	
									esitoOperazione = gestioneServizio(serverConnesso,param,ServerSecondario);
									//Gestione della risposta al Terminale WAP
									gestineRisposta(response,esitoOperazione,param);
									//Decremento del contatore
									ContServer_II = ContServer_II-1;
    			  		}catch(SocketException sex_2)
    			  			{	System.out.println("Connessione al Server Secondario: "+ServerSecondario+" fallita");
    			  				//Gestione della risposta al Terminale WAP
										gestineRisposta(response,false,param);
    			  			 	System.out.println("Errore Socket  "+sex_2.getMessage());
    			  		 	}
						 	}
    			}else
    				{try
    					{	
    						//Creazione connessione con il Server WEB remoto
    						serverConnesso = connessioneServerWEB(ServerSecondario,remotePort);
    						//Incremento del contatore	
								ContServer_II = ContServer_II+1;
							  //Gestione della richiesta	
							  esitoOperazione = gestioneServizio(serverConnesso,param,ServerSecondario);
							  //Gestione della risposta al Terminale WAP
								gestineRisposta(response,esitoOperazione,param);
							  //Decremento del contatore
							  ContServer_II = ContServer_II-1;
    			  	}catch(SocketException sex_3)
    			  		{try
    			  			{	System.out.println("Connessione al Server Principale: "+ServerSecondario+" fallita");
    			  				//Creazione connessione con il Server WEB remoto
    								serverConnesso = connessioneServerWEB(ServerPrincipale,remotePort);
    								//Incremento del contatore	
										ContServer_I = ContServer_I+1;
										//Gestione della richiesta	
										esitoOperazione = gestioneServizio(serverConnesso,param,ServerPrincipale);
										//Gestione della risposta al Terminale WAP
										gestineRisposta(response,esitoOperazione,param);
										//Decremento del contatore
										ContServer_I = ContServer_I-1;		
    			  			 }catch(SocketException sex_4)
    			  			 	{System.out.println("Connessione al Server Secondario:  "+ServerPrincipale+" fallita");
    			  			 		//Gestione della risposta al Terminale WAP
										 gestineRisposta(response,false,param);
    			  			 	 System.out.println("Errore Socket   "+sex_4.getMessage());
    			  		 	 	}
    						}
    				} 
			//	System.out.println("---------------------------------");	
    }

    public String getServletInfo()
    {
        return "ContatoreWAP";
    }
}